package BBUVA;

import java.util.ArrayList; 

// <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
// #[regen=yes,id=DCE.8F843904-A5A7-E726-2B5B-56E677DC7653]
// </editor-fold> 
public class Producto {


    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.44848963-DE3A-9EE7-25D9-33D42E39064A]
    // </editor-fold> 
    private String numeroProducto;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.9646CBEB-B00F-57D4-B187-1C3790F751D8]
    // </editor-fold> 
    private ArrayList<Titular> mTitular;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.03BFE281-4414-BF08-6AF9-60A5B4A44A26]
    // </editor-fold> 
    private ArrayList<Movimiento> mMovimiento;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.179818DC-1ACE-6706-8C74-15BB78CFBBFF]
    // </editor-fold> 
    public Producto () {
        mMovimiento = new ArrayList<Movimiento>();
        mTitular = new ArrayList<Titular>();
    }

    public void addTitular(Titular get) {
        mTitular.add(get);
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.88850FC4-AF30-8629-7C9D-F63893C3FCBD]
    // </editor-fold> 
    public String getNumeroProducto () {
        return numeroProducto;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.ACBC729E-F54F-4B85-6449-18A1165D39A5]
    // </editor-fold> 
    public void setNumeroProducto (String val) {
        this.numeroProducto = val;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.3C177884-D52C-7D6B-89C3-3A164E775081]
    // </editor-fold> 
    public ArrayList<Titular> getTitular () {
        return mTitular;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.6A900B94-6466-7D28-5F3F-8D8A3435B948]
    // </editor-fold> 
    public void setTitular (ArrayList val) {
        this.mTitular = val;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.8A3B4BCA-C011-36A8-B32B-8D2632A900AA]
    // </editor-fold> 
    public ArrayList<Movimiento> getMovimiento () {
        return mMovimiento;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.BAD0BB36-6CA6-B2A6-DE52-65CB0EDC1281]
    // </editor-fold> 
    public void setMovimiento (ArrayList<Movimiento> val) {
        mMovimiento = val;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.889F2556-AC98-9595-F060-2DC4B6973CC5]
    // </editor-fold> 
    public float getSaldo () {
        float saldo=0;
        for(int i=0;i<mMovimiento.size();i++)
            saldo = saldo + mMovimiento.get(i).getCambioSaldo();
        return saldo;
    }

    public ArrayList<Movimiento> getUltimosMovimientos() {
        ArrayList<Movimiento> devolver=new ArrayList<Movimiento>();
        int movs=mMovimiento.size();
        if(movs>5) movs=5;
        for(int i=mMovimiento.size()-movs;i<mMovimiento.size();i++) {
            devolver.add(mMovimiento.get(i));
        }
        return devolver;
    }

    public ArrayList<Movimiento> getOperRemesas() {
        ArrayList<Movimiento> devolver=new ArrayList<Movimiento>();
        for(int i=0;i<mMovimiento.size();i++) {
            if(mMovimiento.get(i).getClass()==OperRemesa.class)
                devolver.add(mMovimiento.get(i));
        }
        return devolver;
    }

    @Override
    public String toString() {
        return this.getNumeroProducto()+"\t"+this.getSaldo();
    }

    public String descripcion() {
        String cadena=this.toString();
        cadena+="\nTITULARES";
        for(int i=0;i<this.getTitular().size();i++) {
            cadena+="\n   "+ this.getTitular().get(i)+"\n";
        }
        cadena+="\n";
        return cadena;
    }
}