package BBUVA;

import java.util.ArrayList;

public class Arqueo {

    private ArrayList<Movimiento> movs;
    private float saldoInicial;
    private float saldoFinal;
    private boolean finalizado=false;

    public Arqueo (float saldo) {
        this.saldoInicial=saldo;
        movs = new ArrayList<Movimiento>();
    }

    public ArrayList<Movimiento> getMovs() {
        return movs;
    }

    public void setMovs(ArrayList<Movimiento> movs) {
        this.movs = movs;
    }

    /**
     * @return the saldoInicial
     */
    public float getSaldoInicial() {
        return saldoInicial;
    }

    /**
     * @return the saldoFinal
     */
    public float getSaldoFinal() {
        return this.saldoFinal;
    }

    public float getSaldoFinalTeorico() {
        float devolver= this.saldoInicial;
        for(int i=0;i<this.movs.size();i++)
            devolver+=this.movs.get(i).getCambioSaldo();
        return devolver;
    }

    public void actualizarSaldoFinalComoTeorico() {
        this.setSaldoFinal(this.getSaldoFinalTeorico());
    }

    /**
     * @return the finalizado
     */
    public boolean isFinalizado() {
        return finalizado;
    }

    /**
     * @param finalizado the finalizado to set
     */
    public void setFinalizado(boolean finalizado) {
        this.finalizado = finalizado;
    }

    /**
     * @param saldoFinal the saldoFinal to set
     */
    public void setSaldoFinal(float saldoF) {
        this.saldoFinal = saldoF;
    }

    void anadirMovimiento(Movimiento get) {
        this.getMovs().add(get);
    }

    void setSaldoInicial(int i) {
        this.saldoInicial=i;
    }
}